uk.ac.starlink.cdf

## Class CdfTableBuilder

- java.lang.Object
- - uk.ac.starlink.table.formats.DocumentedTableBuilder
  - - uk.ac.starlink.cdf.CdfTableBuilder

- All Implemented Interfaces:
    Documented, DocumentedIOHandler, TableBuilder

      public class CdfTableBuilder
      extends DocumentedTableBuilder

  Table input handler for NASA CDF (Common Data Format) files.
  Since:
    24 Jun 2013

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static CdfTableProfile` | `DEFAULT_PROFILE` Default CDF-StarTable translation profile.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CdfTableBuilder()` Constructs a default Cdf table builder.
    `CdfTableBuilder(CdfTableProfile profile)` Constructs a Cdf table builder with a custom translation profile.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canImport(java.awt.datatransfer.DataFlavor flavor)` Returns false.
    `boolean` | `canStream()` Indicates whether this handler can read tables from a stream.
    `static CdfTableProfile` | `createProfile(boolean invarParams, java.lang.String[] descripAttNames, java.lang.String[] unitAttNames, java.lang.String[] blankvalAttNames)` Constructs an instance of CdfTableProfile with some suggestions for attribute names with known semantics.
    `boolean` | `docIncludesExample()` Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler.
    `java.lang.String` | `getFormatName()` Returns "CDF".
    `java.lang.String` | `getXmlDescription()` Returns user-directed documentation in XML format.
    `StarTable` | `makeStarTable(DataSource datsrc, boolean wantRandom, StoragePolicy storagePolicy)` Constructs a `StarTable` based on a given `DataSource`.
    `void` | `streamStarTable(java.io.InputStream in, TableSink sink, java.lang.String pos)` Throws a TableFormatException.

    - ### Methods inherited from class uk.ac.starlink.table.formats.DocumentedTableBuilder

      `getExtensions, looksLikeFile`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface uk.ac.starlink.table.formats.DocumentedIOHandler

      `matchesExtension, readText, toLink`

- - ### Field Detail

    - #### DEFAULT_PROFILE

          public static final CdfTableProfile DEFAULT_PROFILE

      Default CDF-StarTable translation profile.

  - ### Constructor Detail

    - #### CdfTableBuilder

          public CdfTableBuilder()

      Constructs a default Cdf table builder.

    - #### CdfTableBuilder

          public CdfTableBuilder(CdfTableProfile profile)

      Constructs a Cdf table builder with a custom translation profile.
      Parameters:
        `profile` - CDF-Startable translation profile

  - ### Method Detail

    - #### getFormatName

          public java.lang.String getFormatName()

      Returns "CDF".
      Returns:
        one-word description of this handler's format

    - #### makeStarTable

          public StarTable makeStarTable(DataSource datsrc,
                                         boolean wantRandom,
                                         StoragePolicy storagePolicy)
                                  throws java.io.IOException

      Description copied from interface: `TableBuilder`
      Constructs a `StarTable` based on a given `DataSource`. If the source is not recognised or this builder does not know how to construct a table from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      The `wantRandom` parameter is used to indicate whether, ideally, a random-access table should be returned. There is no requirement for the builder to honour this request, but if it knows how to make both random and non-random tables, it can use this flag to decide which to return.

      Note: the presence of the `wantRandom` parameter is somewhat misleading. TableBuilder implementations usually should, and do, ignore it (it would be removed from the interface if it were not for backward compatibility issues). Regardless of the value of this parameter, implementations should return a random-access table only if it is easy for them to do so; in particular they should not use the supplied `storagePolicy`, or any other resource-expensive measure, to randomise a sequential table just because the `wantRandom` parameter is true.

      Parameters:
        `datsrc` - the DataSource containing the table resource
        `wantRandom` - whether, preferentially, a random access table should be returned
        `storagePolicy` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        a StarTable made out of `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### canImport

          public boolean canImport(java.awt.datatransfer.DataFlavor flavor)

      Returns false. I don't think there is a MIME type associated with the CDF format. References to application/x-cdf and application/cdf appear on the web, but neither is IANA registered, and I think they refer to some other format.
      Parameters:
        `flavor` - the DataFlavor whose suitability as stream input is to be assessed
      Returns:
        `true` iff this builder reckons it stands a good chance of turning a stream of type `flavor` into a `StarTable`

    - #### streamStarTable

          public void streamStarTable(java.io.InputStream in,
                                      TableSink sink,
                                      java.lang.String pos)
                               throws java.io.IOException

      Throws a TableFormatException. CDF is not suitable for streaming.
      Parameters:
        `in` - input stream containing table data
        `sink` - destination of the table
        `pos` - position identifier describing the location of the table within the stream; see `DataSource.getPosition()` (may be null)
      Throws:
        `TableFormatException` - if the table can't be streamed or the data is malformed
        `java.io.IOException` - if some other error occurs

    - #### getXmlDescription

          public java.lang.String getXmlDescription()

      Description copied from interface: `Documented`
      Returns user-directed documentation in XML format.

      The output should be a sequence of one or more <P> elements, using XHTML-like XML. Since rendering may be done in a number of contexts however, use of the full range of XHTML elements is discouraged. Where possible, the content should stick to simple markup such as the elements P, A, UL, OL, LI, DL, DT, DD EM, STRONG, I, B, CODE, TT, PRE.

      Returns:
        XML description of this object

    - #### docIncludesExample

          public boolean docIncludesExample()

      Description copied from interface: `DocumentedIOHandler`
      Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler. Binary formats, or instances for which the `Documented.getXmlDescription()` method already includes some example output, should return false.
      Returns:
        true if the user documentation would benefit from the addition of an example serialization

    - #### canStream

          public boolean canStream()

      Description copied from class: `DocumentedTableBuilder`
      Indicates whether this handler can read tables from a stream.
      Specified by:
        `canStream` in class `DocumentedTableBuilder`
      Returns:
        true iff this handler can read from streams

    - #### createProfile

          public static CdfTableProfile createProfile(boolean invarParams,
                                                      java.lang.String[] descripAttNames,
                                                      java.lang.String[] unitAttNames,
                                                      java.lang.String[] blankvalAttNames)

      Constructs an instance of CdfTableProfile with some suggestions for attribute names with known semantics.
      Parameters:
        `invarParams` - true for turning non-row-varying variables into table parameters, false for turning them into variables
        `descripAttNames` - ordered list of names of attributes that might supply description metadata
        `unitAttNames` - ordered list of names of attributes that might supply units metadata
        `blankvalAttNames` - ordered list of names of attributes that might supply magic blank values
      Returns:
        new profile instance